
import socket
import subprocess
import logging

import random

log = logging.getLogger('sim_server')
log.setLevel(logging.DEBUG)
lf = logging.FileHandler('server.log')
lf.setLevel(logging.DEBUG)
log.addHandler(lf)

class SimpleServer(object):
    def __init__(self, interface='', port=4446):
	print 'interface = ' + str(interface)
        print 'port = ' + str(port)
        log.debug('interface= ' + str(interface) + ' port = ' + str(port))
        self.servsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.servsock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.servsock.bind((interface, port))
        self.servsock.listen(socket.SOMAXCONN)
        self.servsock.settimeout(0.1)
        self.sims = []
	print "SimpleServer object initialised"
        log.debug('SimpleServer object initialised')

    def serve(self):
	print "SimpleServer object serving"
        log.debug('SimpleServer object serving')
        try:
            while True:
                to_del = []
                for c,a,p in self.sims:
                    p.poll()
#                    print p, p.returncode
                    if p.returncode !=None:
                        log.debug('Subprocess quit: '+str(c)+' '+str(a)+' '+str(p))
                        print 'QUIT'
                        to_del.append((c,a,p))
                for x in to_del:
                    try:
                        log.debug('Shutdown socket '+str(c)+' '+str(a)+' '+str(p))
                        x[0].shutdown(socket.SHUT_RDWR)
                        x[0].close()
                    except:
                        print "Error: socket shutdown failed"
                        log.debug('Shutdown socket failed'+str(c)+' '+str(a)+' '+str(p))
                    self.sims.remove(x)


                try:
                    conn, addr = self.servsock.accept()
                    print "SimpleServer: accepting client connection and generating socket"
                    log.debug('Accepting connection '+ str(conn) + ' ' + str(addr))
                    print conn, addr

		    # create key
                    key = random.SystemRandom().getrandbits(60)
                    # send key
                    conn.sendall(str(key)+'\n')
                    # expected key   
                    expectedKey = str(key) + '_mama'
                    # read client key		
                    resp = conn.makefile().readline().strip()
                    #print 'Client authentication: ', resp
	            authenticated = False
		    expectedEncodedKey = 'eee'
	            try:
			import hashlib
			expectedEncodedKey = hashlib.sha256(expectedKey).hexdigest()
			#decodedMsg = long(resp)
                        #print 'DATA: ', expectedEncodedKey, resp
		        authenticated = (resp == expectedEncodedKey)
                    except:
                         print 'Problemos...'  + expectedEncodedKey
                    # authenticate client
                    if authenticated:
                    	conn.sendall('True\n')
                        p = subprocess.Popen(['python','-u', 'sim_driver.py'],
                                             stdin=conn.makefile('r+'),
                                             stdout=conn.makefile('w+'))
                        self.sims.append((conn, addr, p))
                        log.debug('creating subprocess '+str(p))
                    else:
                        conn.shutdown(socket.SHUT_RDWR)
                        conn.close()
                        log.debug('authetication failure ')
                        
                except socket.timeout:
                    log.debug('socket timeout')
        
        except:
            log.exception('Exception in server loop')
            raise

#print socket.gethostbyname(socket.gethostname())
import sys
s=SimpleServer(port=int(*sys.argv[1:]))
s.serve()
